// Copyright 2022 schukai GmbH
// SPDX-License-Identifier: AGPL-3.0

package xflags

import (
	"flag"
	"io"
)

func (s *Settings[C]) initCommands(name string) {
	s.command = buildCommandStruct[C](s, name, "", s.config.errorHandling, []string{})
	s.command.parseStruct(s.definitions)
}

type config struct {
	errorHandling flag.ErrorHandling
}

type Settings[C any] struct {
	definitions C

	command *cmd[C]

	errors     []error
	flagOutput io.Writer

	args []string

	config config

	shadow      any
	wasExecuted bool

	hint string
}

func (s *Settings[C]) GetValues() C {
	return s.definitions
}
