// Copyright 2022 schukai GmbH
// SPDX-License-Identifier: AGPL-3.0

package xflags

import "reflect"

// SetShadow sets the shadow struct for the flag configuration.
func (s *Settings[C]) SetShadow(shadow any) *Settings[C] {

	if reflect.TypeOf(shadow).Kind() != reflect.Ptr {
		s.errors = append(s.errors, ShadowMustBePointerError)
		return s
	}

	if reflect.TypeOf(shadow).Elem().Kind() != reflect.Struct {
		s.errors = append(s.errors, ShadowMustBePointerError)
		return s
	}

	s.shadow = shadow
	return s
}
